def lessEqual( node1, node2 ):
        return node1 is node2 or node1.isChildOf( node2 )

def dc( nhg, region1, region2 ):
    r  = nhg.getClosure( region1 | region2 )
    r1 = nhg.getClosure( region1 ) 
    r2 = nhg.getClosure( region2 ) 
    return r is None and r1 is not None and r2 is not None and not r1.hasPart( r2 ) and not r2.hasPart( r1 )

def ec( nhg, region1, region2 ):
    r  = nhg.getClosure( region1 | region2 )
    r1 = nhg.getClosure( region1 ) 
    r2 = nhg.getClosure( region2 ) 
    return r is not None and r.interior is None \
            and lessEqual( r, r1 ) and lessEqual( r, r2 ) \
            and ( r1.interior is None or not lessEqual( r2, r1.interior) ) \
            and ( r2.interior is None or not lessEqual( r1, r2.interior) ) \
            and r1 is not nhg.universe and r2 is not nhg.universe

def po( nhg, region1, region2 ):
    r = nhg.getClosure( region1 | region2 )
    return r is not None and r.interior is not None and nhg.getClosure( region1 ).hasPart( r ) and nhg.getClosure( region2 ).hasPart( r )


def tpp( nhg, region1, region2 ):
    r  = nhg.getClosure( region1 | region2 )
    r1 = nhg.getClosure( region1 ) 
    r2 = nhg.getClosure( region2 ) 

    return r is not None and r1 is not None and r2 is not None and r2.interior is not None \
            and r2.closure.hasPart( r1.closure ) and not r2.interior.hasPart( r1.closure ) \
            and r2.interior.hasPart( r1.interior )

def tppI( nhg, region1, region2 ):
    return tpp( nhg, region2, region1 )

def ntpp( nhg, region1, region2 ):
    r = nhg.getClosure( region1 )
    r2 = nhg.getClosure( region2 )
    return r is not None and r2 is not None and r2.interior is not None and r2.interior.hasPart( r.closure )

def ntppI( nhg, region1, region2 ):
    return ntpp( nhg, region2, region1 )

def eq( nhg, region1, region2 ):
    for region in nhg.all_regions:
        if region.isAbout( region2 ) and not region.isAbout( region1 ):
            return False
        if region.isAbout( region1 ) and not region.isAbout( region2 ):
            return False
    return nhg.getClosure( region1 ) is not None

def rcc8( nhg, region1, region2 ):
    rels = list(  )
    #region1 = set( region1 )
    #region2 = set( region2 )
    for rel in [ dc, ec, po, eq, tpp, tppI, ntpp, ntppI ]:
        if rel( nhg, region1, region2 ):
            rels.append( rel )

    if len( rels ) != 1:
        raise Exception( region1, region2, map( lambda x: x.__name__, rels ), nhg.toDot(  ) )
    return rels[0]

def Constrain( region1, rel, region2 ):
    region1 = set( region1 )
    region2 = set( region2 )
    con =  lambda nhg: rel( nhg, region1, region2 )
    con.__doc__ = str( region1 ) +" "+ rel.__name__ + " " + str( region2 )
    return con

