from Graph import NeighborhoodGraph
from RCC8 import *
import os

DCtoEC = NeighborhoodGraph.transformDCToEC
ECtoPO = NeighborhoodGraph.transformECToPO
POtoEQ = NeighborhoodGraph.transformPOtoEQ
POtoTPP = NeighborhoodGraph.transformPOtoTPP
POtoTPPi = NeighborhoodGraph.transformPOtoTPPi
TPPtoNTPP = NeighborhoodGraph.transformTPPtoNTPP
TPPitoNTPPi = NeighborhoodGraph.transformTPPitoNTPPi

A = 'A'
B = 'B'
C = 'C'
D = 'D'
E = 'E'
F = 'F'
G = 'G'
H = 'H'
I = 'I'
J = 'J'

class NHG:
    def __init__( self, n ):
        self.nhg = self.__createStart( n )
        self.constrains = list(  )

    def __createStart( self, n ):
        import string
        nhg = NeighborhoodGraph(  )
        for a in string.ascii_uppercase[:n]:
            nhg.createNewRegion( a )
        return nhg

    def printRCC8( self ):
        names = sorted( list( self.nhg.getRegionNames(  ) ) )
        for idx, name in enumerate( names ):
            for n2 in names[idx+1:]:
                print name, rcc8( self.nhg, set( ( name, ) ), set( ( n2, ) )).__name__, n2

    def log( self ):
        for l in self.nhg.log.logLines:
            print l


    def pp( self , r1 = None, r2 = None):
        r = []
        if r1 is not None:
            r.append( r1 )
        if r2 is not None:
            r.append( r2 )
        for t in self.nhg.getPossibleTransitions( regions=r, constrains=self.constrains ):
            print t[0], t[1], t[2].__name__[9:]

    def addConstrain( self, r1, rel, r2 ):
        self.constrains.append( Constrain( r1, rel, r2 ) )

    def checkConstrains( self ):
        good = True
        for c in self.contrains:
            print c.__doc__,
            if c( nhg ):
                print "[OK]"
            else:
                print "[FAILED]"
                good = False
        return good

    def trans( self, r1, r2, trans ):
        self.__doManualTransform( trans, r1, r2, "tmp"  )

    def numTransitions( self ):
        return self.nhg.profile.numberOfExploredStates

    def display( self ):
        self.printToFile(  )
        self.displayGraph(  )

    def displayGraph( self, filename = "tmp" ):
        os.system( "dot -Tpng -O %s.dot" % filename )
        os.system( "open %s.dot.png" % filename )

    def printToFile( self, fn = "tmp.dot"):
        print "writing to file:", fn, "..."
        f = open( fn, "w" )
        f.write( self.nhg.toDot(  ) )
        f.close(  )

    def __doManualTransform( self, trans, r1, r2, name ):
        self.__doManualTransform2( trans, [r1], [r2], name )

    def __doManualTransform2( self, trans, r1, r2, name ):
        print "-"*12
        trans(self.nhg, r1, r2 )
        self.printRCC8( )


